#define HASSNPRINTF 1
#ifndef __P
#define __P(proto) proto
#endif


#define DISCLAIMER 1        /* CHANGE TO 1 FOR DISCLAIMER USAGE.      */
                            /* CHANGE TO 0 FOR NO DISCLAIMER USAGE.   */

#define MAX_DISCL_SZ 2500   /* MAXIMUM SIZE OF DISCLAIMER.            */
#define BND_SZ 80           /* MAX Boundary size                      */
#include <fcntl.h>
#ifdef linux
#include <getopt.h>
#endif 
#include <stdio.h>
#include <string.h>
#include <sysexits.h> 
#include <termios.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "libmilter/mfapi.h"

/*
 * Al Smith <Al.Smith@aeschi.ch.eu.org>  May 9 2000
 *
 * Enhancements submitted by Sven Nielsen <dalvenjah@dal.net>  May 13 2000
 * Inline rejection suggested by Paul Yeh <Paul.Yeh@abc.com>   May 24 2000
 * Standard disclaimer by  Wouter Wijker<w.wijker@tiscali.nl>  Jul 12 2000
 * Standard disclaimer bug-fixes Wouter Wijker<w.wijker@tiscali.nl> SEP 8 2000
 * Standard disclaimer for sendmail 8.11.1  06-10-2000  **W.Wijker**
 *
 * Please note that this code requires sendmail-8.11.1 or newer.
 *
 * This code is distributed under the GNU General Public License.
 * Share and enjoy.
 */

/*
 * HISTORY (*WW*)
 * Sep  3  2003 -- Added "zi" extension to also block variant of Sobig virus.
 * Sep  3  2003 -- Re-positioning of #defines to compile without DISCLAIMER usage.
 *                 Thanks: Milan Kerslager<milan.kerslager@pslib.cz>
 * Aug 19  2003 -- QAD-patch to test Lotus-Notes client.
 * Mar 20  2003 -- Synchronised with vbsfilter 1.11.a
 * Jul  1  2002 -- Improved detection of Attachment-name.
 * Jun 26  2002 -- Unquoted boundary in Outlook-Express 5.50.4133.2400
 *              -- Addition of mpg, mpe, eml, mp3 and wav to list of extensions.
 * Jun 25  2002 -- Synchronized this version with vbsfilter 1.9
 *                 Modified version of detect_header.
 *                 Included the suggestions from :
 *
 * Ross Bergman <rbergman@vividusa.com> noted that some malformed endings,
 * for example "foo.exe.". Also that a file can have a CLSID as a file
 * extension, again hidden by windows, and Windows will use the CLSID to
 * determine how to open the attachment.
 *
 * Updated vbsfilter to detect uuencoded attachments.
 * Thanks to Matthew Wong <matthew_wong@aelhk.com.hk> for noting
 * that the "MyParty" virus spreads itself in this way.
 *
 * Various fixes for the case where headers and/or body are empty.
 * Patch sent in by Sergiy Zhuk <serge@yahoo-inc.com>
 *
 * Update "dangerous extension" list.
 * Noted by David F. Russell <David.F.Russell@ncmail.net>
 *
 * Mar 05  2002 -- Correction for "filename="=?iso-8859-1?Q?Install=5Fclient.bat?="
 *                 Content-type: application/octect/stream;
 *                 Means that the fishy extension is not in the last 4 chars.
 * Dec 10  2001 -- Block SCR files.
 * Nov  6  2001 -- Block HTA en REG ivm JS/Seeker.i virus.
 * Nov  1  2001 -- Block MPE
 * Okt  24 2001 -- Block pif usage.
 * Sept 19 2001 -- Block eml usage. (NIMDA virus)
 * Sept 17 2001 -- Block mpg usage. (too much net traffic)
 * Aug  6  2001 -- Added extensions to prevent SirCamm virus. (PIF LNK)
 * May  15 2001 -- Attempt to prevent memory leakage by re-construct
 *                 of realloc() phrasing.
 * Apr  9  2001 -- Prevent double execution of replacebody() when both
 *                 exe->txt and disclaimer are choosen.
 * Mar  20 2001 -- Automatic boundary detection and support of
 *                 Netscape-messenger. (MIME) ( Suggestion Jai Lamerton)
 *                 Disclaimer tested for: Netscape Communicator 4.76
 *                                        OUTLOOK-97
 *                                        OUTLOOK-Express
 *                                        OUTLOOK-2000
 *                                        Eudora 5.0.2
 * Okt  6  2000 -- Changes for sendmail 8.11.1
 * Okt  3  2000 -- Changing MIME exe attachements to txt.
 * SEPT 8  2000 -- UPDATES to 1.3 and bug-fixing Disclaimer.
 * July 26 2000 -- Addition of Legal Disclaimer functionality. (W Wijker)
 * June 20 2000 -- vbsfilter-1.2
 * Add recognition of .SHS attachments.
 *
 * May 24 2000 -- vbsfilter-1.1
 * Add recognition of inline VBS attachments.
 * Libmilter doesn't let us modify the headers, so such mails
 * must be rejected.
 *
 * May  9 2000 -- vbsfilter-1.0
 * Filter incoming visual basic script attachments into text attachments,
 * by changing the .vbs filename suffix into .txt.
 */

#if DISCLAIMER == 1
/*****************************************************************************/
/* REPLACE MY LEGAL RUBBISH BELOW WITH YOUR OWN LEGAL RUBBISH FORCED         */
/* UPON YOU BY YOUR OWN WELL PAYED LAWYERS.                                  */
/*                                                                           */
/*****************************************************************************/
 static char DISCL[MAX_DISCL_SZ]=
"\nDit e-mail bericht is slechts bestemd voor de persoon of organisatie aan wie het is gericht. Het bericht kan informatie bevatten die persoonlijk of vertrouwelijk is. Tevens kan het informatie bevatten die niet publiekstoegankelijk van aard is. CVG aanvaardt geen aansprakelijkheid indien de inhoud van dit bericht en eventuele bijlagen in strijd is met wet of goede zeden. Indien de ontvanger van dit bericht niet de bedoelde persoon of organisatie is, wordt hierbij vermeld dat verdere verspreiding, openbaarmaking of vermenigvuldiging van dit bericht strikt verboden is en verzoeken wij u de inhoud niet te gebruiken en de afzender direct te informeren door het bericht te retourneren. Dank voor uw medewerking \n  
+******+ \n
This e-mail message is meant solely for the person or organisation to whom it is adressed. The message may contain personal or confidential information, or information that is not public in nature. CVG accepts no responsibility for message content and possible attachments that are unlawful or of questionable decency. Further dissemination, publication or duplication of this message is strictly prohibited if the person or organisation receiving this message is not the intended recipient. In the event that you are not the intended recipient, we request you to refrain from using the content and to immediately inform the the sender of the error by returning the message. Thank you for your co-operation. \r\n";

/*****************************************************************************/
/* REPLACE IN BELOW LINE THE TEXT BY THE DOMAIN YOU WANT THE DISCLAIMER USED */
/* FOR.                                                                      */
/*****************************************************************************/
static char OURDOMAIN[]="cvg.nl"; /* <----- Change to YOUR domain!!!! */
static char CDSP[]="\nContent-Disposition";
static char CTYP[]="\nContent-Type";
static char ATTACHNAME[60];
#endif
static int RejectItAll = 1;       /* Change to 0 for extension substitution.(xx.TXT)*/
                                  /* Cvgfilter standard REJECTS everything.       */
/******************************************************************************/
/********          END REPLACEMENTS    ****************************************/
/******************************************************************************/
static char ATTACHNAME[60];

struct mlfiPriv {
	int   len;
	u_char *body;
	int   addver;
#if DISCLAIMER == 1
        int    internal_sender;
        int    txtdiscl_inserted;
        int    htmldiscl_inserted;
        int    allow;
        int    htmlallow;
        char   boundary[BND_SZ];
        int    msgtype;
#endif
};

#if DISCLAIMER == 1
int insert_disclaimer(struct mlfiPriv *priv);
void initDisclaimer(SMFICTX *ctx, char *envfrom);
void detectMsgFormat(SMFICTX *ctx,char *headerf,char *headerv);
#endif
void getAttachName(char *endp);
/*
 * Microsoft considers these extensions dangerous:
 * http://support.microsoft.com/support/kb/articles/Q262/6/17.ASP
 */
static char *exts[] = { "ade", "adp", "bas", "bat", "chm", "cmd", "com",
        "cpl", "crt", "exe", "hlp", "hta", "inf", "ins", "isp", "js", "jse",
        "lnk", "mdb", "mde", "msc", "msi", "msp", "mst", "pcd", "pif", "reg",
        "scr", "sct", "shs", "shb", "url", "vb", "vbe", "vbs", "wsc", "wsf",
        "wsh", "mpg", "mpe", "eml", "wav", "mp3","zi", NULL };

#define VERTEXT "X-Filter-Version"
#define VERSION "1.12.Cvg-Notes"

#define MLFIPRIV ((struct mlfiPriv *) smfi_getpriv(ctx))

extern sfsistat mlfi_cleanup(SMFICTX *, sfsistat);

/******************************************************/
static int nocase_strncmp(const char *s1, const char *s2, int len) {
        register int n = len;

        for (; n; s1++, s2++, n--) {
                if (tolower(*s1) != tolower(*s2)) return (1);
        }
        return(n > 0);
}
/******************************************************/
static char * nocase_strstr(const char *s1, const char *s2) {
	const char *p, *q, *r;
	char x, y;
	for(p = s1; *p; p++) {
		for(q = s2, r = p; *q && *r; q++, r++) {
			x = (isalpha((int) *q)) ? tolower(*q) : *q;
			y = (isalpha((int) *r)) ? tolower(*r) : *r;

			if (x != y) break;
		}
		if (!*q) {
			return((char *) p);
		} else if (!*r) {
			return(NULL);
		}
	}
	return(NULL);
}
/******************************************************/
static int detect_header(u_char *body, char *header, char *subfield, char **exts, char *ext2) 
{ /* Slightly modified by *WW* on 26-6-2002
   */
char *p, *q, *r;
int i, lfcnt, rc = 0, quoted;
char **ext;
for(p = (char *) body; p && (p = nocase_strstr(p, header)); p++) 
   { for(lfcnt = 0, q = p+strlen(header); *q && lfcnt < 3; q++)
        { if (*q == '\n')
             { lfcnt++;
             }
          else 
             { if (!nocase_strncmp(q, subfield, strlen(subfield)))
                  {
                   r=q+strlen(subfield);
                   quoted = (*r == '"');
                   if (quoted)
                      { r++;
                      }
                   for(; *r != '\r' && *r != '\n' && *r != '\0'; r++) 
                      {
                       if (quoted && *r == '"')
                          { break;
                          }
                      }
                   if ((quoted && *r == '"') ||
                         /*  (!quoted && (*r == '\n' || *r == '\r'))) */
                              (*r == '\n' || *r == '\r')) 
                       {
                            if (*(r-1) == '}' && r-q > 39 
                                && *(r-38) == '{' && *(r-39) == '.')
                               {
                                 for(i = 39; i > 0; i--)
                                    { *(r-i) = ' ';
                                    }
                                 rc++;
                                }
/*WW  26-6-2002*/
                            if (*(r-6)  == '.' )
                               {
                                 for(ext = exts; *ext; ext++) 
                                    {
                                      if (strlen(*ext) != 3)
                                         { continue;
                                         }
                                      if (tolower(*(r-5)) == *ext [0] &&
                                          tolower(*(r-4)) == *ext [1] &&
                                          tolower(*(r-3)) == *ext [2])
                                         {
                                          /* Handles the following "funny" stuff:  
                                           * Content-type: application/octet-stream;
                                           * filename"=?iso8859-1?Q?Install=4Fclient.bat?="
                                           */
                                           getAttachName((char *)(r-3));
                                           if (!RejectItAll)
                                               { /* NO Changing to TXT.*/
                                                 *(r-5) = ext2[0];
                                                 *(r-4) = ext2[1];
                                                 *(r-3) = ext2[2];
                                               }
                                            rc++;  
				         }
                                     }
                               }
/*EOF WW 26-6-2002*/
                            if (*(r-5) == '.' && *(r-1) == '.') 
                               {
                                 for(ext = exts; *ext; ext++) 
                                    {
                                      if (strlen(*ext) != 3)
                                         { continue;
                                         }
                                      if (tolower(*(r-4)) == (*ext)[0] &&
                                          tolower(*(r-3)) == (*ext)[1] &&
                                          tolower(*(r-2)) == (*ext)[2]) 
                                         {
                                           getAttachName((char *)(r-2));
                                           if (!RejectItAll)
                                               { /* NO Changing to TXT.*/
                                                 *(r-4) = ext2[0];
                                                 *(r-3) = ext2[1];
                                                 *(r-2) = ext2[2];
                                               }
                                           rc++;
                                         }
                                     }
                                }
                             if (*(r-4) == '.') 
                                {
                                  for(ext = exts; *ext; ext++)
                                     {
                                       if (strlen(*ext) != 3)
                                          {  continue;
                                          }
                                       if (tolower(*(r-3)) == (*ext)[0] &&
                                           tolower(*(r-2)) == (*ext)[1] &&
                                           tolower(*(r-1)) == (*ext)[2])
                                          {
                                           getAttachName((char *)(r-1));
                                           if (!RejectItAll)
                                               { /* NO Changing to TXT.*/
                                                 *(r-3) = ext2[0];
                                                 *(r-2) = ext2[1];
                                                 *(r-1) = ext2[2];
                                               }
                                            rc++;
                                          }
                                      }
                                 }
                              if (*(r-3)  == '.') 
                                 {
                                   for(ext = exts; *ext; ext++)
                                      {
                                        if (strlen(*ext) != 2)
                                           {  continue;
                                           }
                                        if (tolower(*(r-2)) == (*ext)[0] &&
                                            tolower(*(r-1)) == (*ext)[1])
                                            {
                                             getAttachName((char *)(r-1));
                                             if (!RejectItAll)
                                                { /* NO Changing to TXT.*/
                                                  *(r-2) = ext2[0];
                                                  *(r-1) = ext2[1];
                                                }
                                             rc++;
                                            }
                                       }
                                  }
                       }
                  }
             }
        }
  }
return(rc);
}
/******************************************************/
sfsistat mlfi_envfrom(SMFICTX *ctx, char **envfrom) {
	struct mlfiPriv *priv;
	priv = (struct mlfiPriv *)malloc(sizeof *priv);
	if (!priv) {
		/* can't accept this message right now */
		return SMFIS_TEMPFAIL;
	}
        memset(priv,0x00,sizeof(priv));
	priv->body = NULL;
	priv->len  = 0;
	priv->addver = 1;
	smfi_setpriv(ctx, priv);
#if DISCLAIMER == 1
        initDisclaimer(ctx,*envfrom);
#endif
	/* save the private data */
	/* continue processing */
	return SMFIS_CONTINUE;
}
/******************************************************/
sfsistat mlfi_header(SMFICTX *ctx, char *headerf, char *headerv) {
	struct mlfiPriv *priv = MLFIPRIV;
        int found=0;

	if (!strcmp(headerf, VERTEXT)) {
		priv->addver = 0;
	}
#if DISCLAIMER==1      
        detectMsgFormat(ctx,headerf,headerv);
#endif
        if (!nocase_strncmp(headerf, "Content-Disposition", strlen("Content-Disposition")))
 {
                found = detect_header((u_char *) headerv, "", "filename=", exts, "txt");
        }
        if (!nocase_strncmp(headerf, "Content-Type", strlen("Content-Type"))) {
                found += detect_header((u_char *) headerv, "", "name=", exts, "txt");
        }
        if (found) {

             char *tmp_p;
             char MESG[200];
             memset(MESG,0X00,200);
             if (strlen(ATTACHNAME))
                { /* Lets be slightly specific about what module we are rejecting.
                   */
                  strcpy(MESG,"Rejecting inline attachment: ");
                  strcat(MESG,ATTACHNAME);
                  smfi_setreply(ctx,"554", "5.7.0", MESG);
                }
             else
                { /* No details given */
                  smfi_setreply(ctx,"554", "5.7.0", "Rejecting inline attachment");
                }
	     return mlfi_cleanup(ctx, SMFIS_REJECT);
        }
	return SMFIS_CONTINUE;
}
/******************************************************/
sfsistat mlfi_eoh(SMFICTX *ctx) {
        return SMFIS_CONTINUE;
}
/******************************************************/
sfsistat mlfi_body(SMFICTX *ctx, u_char *bodyp, size_t bodylen) {
	struct mlfiPriv *priv = MLFIPRIV;
        u_char *memp;
        memp = (u_char *)realloc(priv->body, priv->len + bodylen +1);
	if (!memp) {
		/* can't accept this message right now */
		return SMFIS_TEMPFAIL;
	}
        priv->body=memp;
	memcpy((u_char*)(priv->body+priv->len), bodyp, bodylen);
        priv->len += bodylen;
        priv->body[priv->len]= '\0';
	/* continue processing */
	return SMFIS_CONTINUE;
}
/******************************************************/
sfsistat mlfi_eom(SMFICTX *ctx) {
	struct mlfiPriv *priv = MLFIPRIV;
	int found_disp = 0, found_type = 0, found_uuencode = 0;
	int found;
	char buf[1024];
	char host[512];
#if DISCLAIMER == 1
        int replaceanyway;
        replaceanyway=0;
#endif
        if (!priv->body) {
                return mlfi_cleanup(ctx, SMFIS_CONTINUE);
        }

	/*
	 * here's an example of what netscape sends out:
	 *
	 * Content-Type: application/octet-stream; name="test.vbs"
	 * Content-Transfer-Encoding: base64
	 * Content-Disposition: inline; filename="test.vbs"
	 */
        found_disp = detect_header(priv->body, "\nContent-Disposition", "filename=", exts, "txt");
        found_type = detect_header(priv->body, "\nContent-Type", "name=", exts, "txt");
        found_uuencode = detect_header(priv->body, "\nbegin ", " ", exts, "txt");

        found = (found_type > found_disp) ? found_type : found_disp;
        found = (found_uuencode > found) ? found_uuencode : found;

        if (RejectItAll && found)
           {  /* Reject  the message and don't even allow a renamed
               * xxxxxx.txt to enter the system.
               * Thus prevent the end-user from changing the extension
               * back to its original value and deliberately
               * clobbering the system. Nice to have on Citrix (WBTS)
               * systems.
               */
             char *tmp_p;
             char MESG[200];
             tmp_p=nocase_strstr(priv->body,"filename=");
             memset(MESG,0X00,200);
             if (strlen(ATTACHNAME))
                { /* Lets be talkative and tell what module is bothering us.
                   */
                  strcpy(MESG,"Rejecting dangerous E-mail attachment: ");
                  strcat(MESG,ATTACHNAME);
                  smfi_setreply(ctx,"554", "5.6.1", MESG);
                }
             else
                { /* No further details about this attachment known.
                   * Reject it anyway.
                   */
                  smfi_setreply(ctx,"554", "5.6.1", "Rejecting this attachment");
                }
	     return mlfi_cleanup(ctx, SMFIS_REJECT);
           }

        if (gethostname(host, sizeof(host)) < 0) {
                strncpy(host, "localhost", sizeof host);
        }
        sprintf(buf, "%s (%s)", VERSION, host);
        if (priv->addver) smfi_addheader(ctx, VERTEXT, buf);  
        if (found) {
                sprintf(buf, "%d attachment%s changed to TXT",
                        found, (found == 1) ? "" : "s");
                smfi_addheader(ctx, "X-Filter", buf);
#if DISCLAIMER == 1
                replaceanyway=1; /* Thanks Jai Lamerton  */
#else
	        smfi_replacebody(ctx, priv->body, priv->len);
#endif
	}
#if DISCLAIMER == 1
        if (insert_disclaimer(priv) || replaceanyway)
           { 
             if (priv->body)
                {
	         smfi_replacebody(ctx, priv->body, priv->len);
                }
           }
#endif
	return mlfi_cleanup(ctx, SMFIS_CONTINUE);
}

/******************************************************/
sfsistat mlfi_close(SMFICTX *ctx) {
	return mlfi_cleanup(ctx, SMFIS_ACCEPT);
} 
/******************************************************/
sfsistat mlfi_abort(SMFICTX *ctx) {
	return mlfi_cleanup(ctx, SMFIS_CONTINUE);
}
/******************************************************/
sfsistat mlfi_cleanup(SMFICTX *ctx, sfsistat rc) {
	struct mlfiPriv *priv = MLFIPRIV;
	if (priv) {
		if (priv->body) free(priv->body);
		free(priv);
		smfi_setpriv(ctx, NULL);
	}

	return(rc);
}
/******************************************************/
struct smfiDesc smfilter = {
	"cvgfilter",	/* filter name */
	SMFI_VERSION,	/* version code -- do not change */
	SMFIF_ADDHDRS | SMFIF_CHGBODY ,	/* flags */
	NULL,		/* connection info filter */
	NULL,		/* SMTP HELO command filter */
	mlfi_envfrom,	/* envelope sender filter */
	NULL,		/* envelope recipient filter */
	mlfi_header,	/* header filter */
	mlfi_eoh,	/* end of header */
	mlfi_body,	/* body block filter */
	mlfi_eom,	/* end of message */
	mlfi_abort,	/* message aborted */
	mlfi_close	/* connection cleanup */
};
/******************************************************/
int main(int argc, char *argv[]) {
	int c, fd;
	const char *args = "p:";

	/* Process command line options */
	while ((c = getopt(argc, argv, args)) != -1) {
		switch (c) {
		  case 'p':
			if (optarg == NULL || *optarg == '\0') {
				(void) fprintf(stderr, "Illegal conn: %s\n",
					       optarg);
				exit(EX_USAGE);
			}
			(void) smfi_setconn(optarg);
			break;

		}
	}

	if (smfi_register(smfilter) == MI_FAILURE) {
		fprintf(stderr, "smfi_register failed\n");
		exit(EX_UNAVAILABLE);
	}

	if (fork() == 0) { /*Child process */
                close(STDIN_FILENO);
                close(STDOUT_FILENO);
                close(STDERR_FILENO);
                fd=open("dev/tty",O_RDWR);
                if (fd>=0)
                   { ioctl(fd,TIOCNOTTY,0);
                     close(fd);
                   }
		return smfi_main();  /* libmilter/main.c */
	} 
	return 0;
}
/********************************/
#if DISCLAIMER==1
int insert_disclaimer(struct mlfiPriv *priv)
   {
    /* Insertion of disclaimer in the text/html and text/plain segments
     * of an E-mail message.
     * The Html-message is minimized in font.
     */
    int RC;
    char *end_boundary;
    char *txtplain_p;
    char *txthtml_p;
    char *boundary_str;
    char *p1;
    u_char *memp;
    char BOUNDARY[BND_SZ];
    char BOUNDARY2[BND_SZ];
    char DISCL2[MAX_DISCL_SZ+100];
    char *tmp_p;
    char *p3, *p4, *p5;
    RC=0;
    memp = (u_char *)realloc(priv->body, priv->len + 5*strlen(DISCL));
    if (!memp) {
         /*  Short of memory
          *  Return without destroying priv->body. (18-5-2001)
          */
           return RC;
	}
    priv->body=memp;
    if (priv->internal_sender && priv->allow && !priv->txtdiscl_inserted)
       { /* Insertion into first part of multipart message.
          */
        txtplain_p=(char *)priv->body;
        txtplain_p=(char *)nocase_strstr(txtplain_p,"Content-Type: text/plain");
        if (strlen((char *)priv->boundary))
           { /* Prefix obtained boundary  by "--"
              */
             memset(BOUNDARY,0X00,80);
             strcpy(BOUNDARY,"--");
             strcat(BOUNDARY,priv->boundary);
           }
        if (strstr(BOUNDARY,"--=_mixed "))
           { /* Lotus Notes client. Separate boundaries for individual parts.
              * =_mixed 23242424 en =_alternative 23242425
              * Test both and alternative boundary first.
              * Boundaries differ in code also. Limit to 7 positions.
              */
              strcpy(BOUNDARY2,BOUNDARY);
              memset(BOUNDARY,0X00,BND_SZ);
              strcpy(BOUNDARY,"--=_alternative ");
              strncat(BOUNDARY,(char *)&BOUNDARY2[10],7);
          }
        else
          {
             if (strstr(BOUNDARY,"--=_alternative "))
                {
                  memset(BOUNDARY2,0X00,BND_SZ);
                  strcpy(BOUNDARY2,"--=_mixed ");
                  strncat(BOUNDARY2,(char *)&BOUNDARY[16],7);
                }
          }
        if (txtplain_p!=(char *)NULL)
           { /* First segment of message 
              */
             txtplain_p+=13;         
             end_boundary=(char *)strstr(txtplain_p, BOUNDARY);
             if (end_boundary!=(char *)NULL)
                { /* Insert the disclaimer
                   */
                  memmove((char *)(end_boundary+strlen(DISCL)),end_boundary,
                                     (strlen(end_boundary) + 1)) ;
                  memcpy((char *)end_boundary,DISCL,strlen(DISCL));
                  priv->len += strlen(DISCL);
                  priv->txtdiscl_inserted=1;
                   RC=1;
                }
           }
        if (txtplain_p!=(char *)NULL && !priv->txtdiscl_inserted)
           { /* Test for second boundary of LOTUS-NOTES client.
              */
             txtplain_p+=13;         
             end_boundary=(char *)strstr(txtplain_p, BOUNDARY2);
             if (end_boundary!=(char *)NULL)
                { /* Insert the disclaimer
                   */
                  memmove((char *)(end_boundary+strlen(DISCL)),end_boundary,
                                     (strlen(end_boundary) + 1)) ;
                  memcpy((char *)end_boundary,DISCL,strlen(DISCL));
                  priv->len += strlen(DISCL);
                  priv->txtdiscl_inserted=1;
                   RC=1;
                }
           }
       }
    if (priv->internal_sender && priv->htmlallow && !priv->htmldiscl_inserted)
       {/* Insertion in first HTML segment of multipart message.
         */
        txthtml_p=(char *)priv->body;
        txthtml_p=(char *)nocase_strstr(txthtml_p,"Content-Type: text/html");
        if (txthtml_p!=(char *)NULL )
           { /* Second segment of  Outlook  (alternative html format)
              * For those mailers with HTML preference that forget
              * everything about their </BODY> and terminate with
              * </html> only(NS Communicator) we have to determine what
              * comes first. End of body or end of html.
              */
             memset(BOUNDARY,0X00,60);
             txthtml_p+=13;         
             p3=(char *)nocase_strstr(txthtml_p, "</body>");
             p4=(char *)nocase_strstr(txthtml_p, "</html>");
             p5=(char *)nocase_strstr(txthtml_p, "</font>");  /* Incomplete html from Notes */
             end_boundary=(char *)NULL;
             if (p3!=(char *)NULL && p4!=(char *)NULL)
                { if (p3<p4)
                     { end_boundary=p3;
                     }
                  else
                     { end_boundary=p4;
                     }
                }
             if (p3==(char *)NULL)
                { end_boundary=p4;
                }
             if (p4==(char *)NULL)
                { end_boundary=p3;
                }
             if (p3==(char *)NULL && p4==(char *)NULL && p5!=(char *)NULL)
                { /* </font> as the end of a HTML message.
                   * Apparently Lotus-Notes does not only forget about <BODY> </BODY>
                   * and <HTML> </HTML>, but also on a lot of other items!
                   */ 
                    end_boundary=p5;
                }
             strcpy(DISCL2,"<H6><BR><HR>");
             strcat(DISCL2,DISCL);
             strcat(DISCL2,"<BR><HR><BR></H6>");
             tmp_p=(char *)nocase_strstr(DISCL2,"+******+");
             if (tmp_p!=(char *)NULL)
                { /* Substitute the marker with a ruler 
                   */                
                  memcpy( tmp_p,"<BR><HR>",8);
                }
             if (end_boundary!=(char *)NULL)
                { /* Insert the disclaimer
                   */
                  memmove((char *)(end_boundary+strlen(DISCL2)),
                                   end_boundary, (strlen(end_boundary)+1));
                  memcpy((char *)end_boundary,DISCL2,strlen(DISCL2));
   	          priv->len += strlen(DISCL2);
                  priv->htmldiscl_inserted=1;
                  RC=1;
                }
           }
       }
    if ( priv->internal_sender  &&
         !priv->htmldiscl_inserted && !priv->txtdiscl_inserted &&
         (priv->msgtype==3 || priv->msgtype==1 || priv->msgtype==2))
       { /* Just one /text/plain message no attachments OUTLOOK-97 MIME.
          * We did not insert anything else before.
          * It is save to add the text disclaimer to the end of the message
          * body.
          */
        memcpy((char *)(priv->body+ priv->len), DISCL, strlen(DISCL));
        priv->len +=strlen(DISCL);
        RC=1;
       }  
    if ( priv->internal_sender  &&
         !priv->htmldiscl_inserted && !priv->txtdiscl_inserted &&
         priv->msgtype==4 ) 
       { /* Just one /text/html message no attachments.
          * We did not insert anything else before.
          */
        txthtml_p=(char *)priv->body;
        if (txthtml_p!=(char *)NULL )
           { /* Second segment of  Outlook  (alternative html format)
              * For those mailers with HTML preference that forget
              * everything about their </BODY> and terminate with
              * </html> only(NS Communicator) we have to determine what
              * comes first. End of body or end of html.
              */
             memset(BOUNDARY,0X00,60);
             txthtml_p+=13;         
             end_boundary=(char *)NULL;
             p3=(char *)nocase_strstr(txthtml_p, "</body>");
             p4=(char *)nocase_strstr(txthtml_p, "</html>");
             if (p3!=(char *)NULL && p4!=(char *)NULL)
                {  /* Both tags present. Find the lowest position. 
                    */
                  if (p3<p4)
                     { end_boundary=p3;
                     }
                  else
                     { end_boundary=p4;
                     }
                }
             if (p3==(char *)NULL)
                { end_boundary=p4;
                }
             if (p4==(char *)NULL)
                { end_boundary=p3;
                }
             strcpy(DISCL2,"<H6><BR><HR>");
             strcat(DISCL2,DISCL);
             strcat(DISCL2,"<BR><HR><BR></H6>");
             tmp_p=(char *)nocase_strstr(DISCL2,"+******+");
             if (tmp_p!=(char *)NULL)
                { /* Substitute the marker with a ruler 
                   */                
                  memcpy( tmp_p,"<BR><HR>",8);
                }
             if (end_boundary!=(char *)NULL)
                { /* Insert the disclaimer
                   */
                  memmove((char *)(end_boundary+strlen(DISCL2)),
                                   end_boundary, (strlen(end_boundary)+1));
                  memcpy((char *)end_boundary,DISCL2,strlen(DISCL2));
   	          priv->len += strlen(DISCL2);
                  priv->htmldiscl_inserted=1;
                  RC=1;
                }
           }

       }  
    return(RC);
   }
/********************************************************/
void initDisclaimer(SMFICTX *ctx, char *envfrom)
{ 
  char *tmp_p;        
  struct mlfiPriv *priv = MLFIPRIV;  

  priv->htmldiscl_inserted = 0;
  priv->txtdiscl_inserted = 0;
  priv->allow=0;
  priv->htmlallow=0;
  priv->internal_sender = 0;
  priv->msgtype =0;
  if ((tmp_p=(char *)nocase_strstr(envfrom,OURDOMAIN))!=(char *)NULL)
     { /* Internal sender
        * Add disclaimer
        */
        priv->internal_sender = 1;
     }
   memset(priv->boundary,0X00,60);
}
/***********************************************************/
void detectMsgFormat(SMFICTX *ctx, char *headerf, char *headerv) 
{
  struct mlfiPriv *priv = MLFIPRIV;  
  char *p1, *p2, *p3;
  if (!nocase_strncmp(headerf,"Content-Type",strlen("Content-Type"))
             && !priv->msgtype) 
       {
        if ((p3=nocase_strstr(headerv,"multipart/")) !=(char *)NULL)
             { /* Allow  hanky-panky with the message-body.
                * Test for multipart message.
                * If so, allow insertion.
                * Determine the boundary-string for separate messages
                * in a mulipart MIME-message.
                */
              if ((p3=nocase_strstr(headerv,"multipart/alternative"))!=(char *)NULL)
                        { /*  Messages consisting of at least two identical
                           *  parts. (First part is plain/text, second is
                           *  the same message in HTML format.
                           */
                          priv->allow=1;
                          priv->htmlallow=1;
                          priv->msgtype=1;   
                        }
               if ((p3=nocase_strstr(headerv,"multipart/mixed"))!=(char *)NULL)
                        { /* Message consisting of multiple parts.
                           * First two parts need not contain the same message.
                           * The first chunk contains the message.
                           * Can be /text/plain or /text/html
                           */
                          priv->allow=1;
                          priv->htmlallow=1;
                          priv->msgtype=2;   
                         }
                      p1=nocase_strstr(headerv,"boundary=\"");
                      if (p1!=(char *)NULL)
                        { /*Quoted boundary 
                           */
                          p1+=strlen("boundary=\"");
                          p2=nocase_strstr((char *)p1,"\"");
                          if (p2!=(char *)NULL)
                             {/* Properly terminated by quote
                               */
                              memset(priv->boundary,0X00,60);
                              strncpy(priv->boundary,p1,(int)(p2-p1));
                             }
                        }
                      else
                        { /* Unquoted boundary. Whats up next??
                           * Outlook Express 5.50.4133.2400
                           */
                          p1=nocase_strstr(headerv,"boundary=");
                          if (p1!=(char *)NULL)
                             {
                               p1+=strlen("boundary=");
                               p2=nocase_strstr((char *)p1,"\n");
                               if (p2==(char *)NULL)
                                  { p2=nocase_strstr((char *)p1,"\r");
                                  }
                               else
                                  {
                                    memset(priv->boundary,0X00,60);
                                    strncpy(priv->boundary,p1,(int)(p2-p1));
                                  }
                             }
                        }
                   }
                if((p3=nocase_strstr(headerv,"text/plain"))!=(char *)NULL)
                   { /*
                      * Test for singular plain text message.
                      */
                      priv->msgtype=3;   
                   }
                if((p3=nocase_strstr(headerv,"text/html"))!=(char *)NULL)
                   { /*
                      * Test for singular message in HTML format.
                      */
                      priv->htmlallow=1;
                      priv->msgtype=4;   
                   }
           }
}
#endif
/***********************************************************/
void getAttachName(char *endp)
{ /* Try to get the offending module-name that we are rejecting..
   * Is a bit more informative in the logfiles.
   */
  int cnt;
  char *p1,*p2;
  memset(ATTACHNAME,0x00,60);
  cnt=0;
  p1=endp;
  p2=endp;
  while( *p1!='=' && *p1!='"' && cnt!=59)
       { *p1--;
         cnt++;
       }
  if ( p1<p2)
     {
       strncpy(ATTACHNAME,p1,(int)(p2-p1+1));
     }
}
